## libsdsl 2.1.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(AppendCompilerFlags)

## Project information ##
project(sdsl CXX C)
set(PROJECT_VENDOR "Simon Gog")
set(PROJECT_CONTACT "simon.gog@gmail.com")
set(PROJECT_URL "https://github.com/simongog/sdsl-lite")
set(PROJECT_DESCRIPTION "SDSL: Succinct Data Structure Library")
set(CMAKE_BUILD_TYPE "Release")

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" PROJECT_VERSION_FULL)
string(REGEX REPLACE "[\n\r]" "" PROJECT_VERSION_FULL "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+$" "\\1" PROJECT_VERSION_MAJOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+)\\.[0-9]+$" "\\1" PROJECT_VERSION_MINOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)$" "\\1" PROJECT_VERSION_PATCH "${PROJECT_VERSION_FULL}")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
math(EXPR LIBRARY_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(LIBRARY_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(LIBRARY_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(LIBRARY_VERSION_FULL "${LIBRARY_VERSION}.${LIBRARY_VERSION_PATCH}")


option(CODE_COVERAGE "Set ON to add code coverage compile options" OFF)
option(GENERATE_DOC "Set ON to genrate doxygen API reference in build/doc directory" OFF)

# C++11 compiler Check
if(NOT CMAKE_CXX_COMPILER_VERSION) # work around for cmake versions smaller than 2.8.10
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE CMAKE_CXX_COMPILER_VERSION)
endif()
if(CMAKE_CXX_COMPILER MATCHES ".*clang.*" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      set(CMAKE_COMPILER_IS_CLANGXX 1)
endif()
if( (CMAKE_COMPILER_IS_GNUCXX AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.7) OR
    (CMAKE_COMPILER_IS_CLANGXX AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.2))
  message(FATAL_ERROR "Your C++ compiler does not support C++11. Please install g++ 4.7 (or greater) or clang 3.2 (or greater)")
else()
  message(STATUS "Compiler is recent enough to support C++11.")
endif()

if( CMAKE_COMPILER_IS_GNUCXX )
    append_cxx_compiler_flags("-std=c++11 -Wall -Wextra -DNDEBUG" "GCC" CMAKE_CXX_FLAGS)
    append_cxx_compiler_flags("-O3 -ffast-math -funroll-loops" "GCC" CMAKE_CXX_OPT_FLAGS)
    if ( CODE_COVERAGE )
        append_cxx_compiler_flags("-g -fprofile-arcs -ftest-coverage -lgcov" "GCC" CMAKE_CXX_FLAGS)
    endif()

else()
    if( CMAKE_COMPILER_IS_CLANGXX )
		append_cxx_compiler_flags("-std=c++11 -DNDEBUG" "CLANG" CMAKE_CXX_FLAGS)
		append_cxx_compiler_flags("-stdlib=libc++" "CLANG" CMAKE_CXX_FLAGS)
		append_cxx_compiler_flags("-O3 -ffast-math -funroll-loops -D__extern_always_inline=\"extern __always_inline\" " "CLANG" CMAKE_CXX_OPT_FLAGS)
	else()
		append_cxx_compiler_flags("/EHsc" "MSVC" CMAKE_CXX_FLAGS)
		append_cxx_compiler_flags("/Od" "MSVC" CMAKE_CXX_FLAGS_DEBUG)
		append_cxx_compiler_flags("/Ox" "MSVC" CMAKE_CXX_FLAGS_RELEASE)
        set(vars CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        foreach(var ${vars})
            string(REPLACE "/MD" "-MT" ${var} "${${var}}")
        endforeach(var)

		add_definitions("/DMSVC_COMPILER")
	endif()
endif()

try_compile(MODE_TI "${PROJECT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/check_mode_ti.cpp")
if( MODE_TI )
  if(MSVC)
    add_definitions("/DMODE_TI")
  else()
    add_definitions("-DMODE_TI")
  endif()
endif()

include(CheckSSE4_2)
if( BUILTIN_POPCNT )
    if( CMAKE_COMPILER_IS_GNUCXX )
        append_cxx_compiler_flags("-msse4.2" "GCC" CMAKE_CXX_OPT_FLAGS)
    else()
        append_cxx_compiler_flags("-msse4.2" "CLANG" CMAKE_CXX_OPT_FLAGS)
    endif()
endif()

# check for demangle support to get pretty C++ class names
include(FindCxaDemangle)
if( HAVE_CXA_DEMANGLE )
    message(STATUS "Compiler supports DEMANGLE.")
    if( CMAKE_COMPILER_IS_GNUCXX )
        append_cxx_compiler_flags("-DHAVE_CXA_DEMANGLE" "GCC" CMAKE_CXX_OPT_FLAGS)
    else()
        append_cxx_compiler_flags("-DHAVE_CXA_DEMANGLE" "CLANG" CMAKE_CXX_OPT_FLAGS)
    endif()
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Make.helper.cmake"
		       "${CMAKE_CURRENT_SOURCE_DIR}/Make.helper" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/lib/structure_tree.cpp.cmake"
               "${CMAKE_CURRENT_SOURCE_DIR}/lib/structure_tree.cpp" @ONLY)

find_package(Git)
if(GIT_FOUND)
    message("git found: ${GIT_EXECUTABLE}")
else()
    message(WARNING "git not found. Cloning of submodules will not work.")
endif()

add_subdirectory(external)
add_subdirectory(include)
add_subdirectory(lib)

## Add doxygen documentation generation target ##
find_package(Doxygen)
if(GENERATE_DOC AND DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/extras/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(docs ALL
${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating API documentation with Doxygen" VERBATIM
)
endif(GENERATE_DOC AND DOXYGEN_FOUND)

## Add 'uninstall' target ##
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall-sdsl
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake")

target_include_directories(sdsl PUBLIC include)

add_subdirectory(test)

=== external/CMakeLists.txt ===
## Add libdivsufsort
set(divsufsort_cmake_file ${CMAKE_CURRENT_LIST_DIR}/libdivsufsort/CMakeLists.txt)
if(NOT EXISTS ${divsufsort_cmake_file})
    EXECUTE_PROCESS(COMMAND git submodule update --init external/libdivsufsort
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/..
                    OUTPUT_QUIET
            )
endif(NOT EXISTS ${divsufsort_cmake_file})

set(BUILD_SHARED_LIBS OFF CACHE BOOL "Do not build a shared library for libdivsufsort")
set(BUILD_EXAMPLES OFF CACHE BOOL "Do not build libdivsufsort example")
set(BUILD_DIVSUFSORT64 ON CACHE BOOL "Build libdivsufsort in 64-bits mode")

add_subdirectory(libdivsufsort)

## Add gtest 
set(gtest_dir ${CMAKE_CURRENT_LIST_DIR}/googletest)
set(gtest_file ${gtest_dir}/CMakeLists.txt)
if(NOT EXISTS ${gtest_file})
    EXECUTE_PROCESS(COMMAND git submodule update --init external/googletest
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/..
                    OUTPUT_QUIET
            )
endif(NOT EXISTS ${gtest_file})

add_subdirectory(googletest)

=== include/CMakeLists.txt ===
add_subdirectory(sdsl)

=== lib/CMakeLists.txt ===
include_directories(#"${CMAKE_CURRENT_SOURCE_DIR}/../include"
        "${CMAKE_CURRENT_BINARY_DIR}/../include"
        "${CMAKE_CURRENT_BINARY_DIR}/../external/libdivsufsort/include"
        )


file(GLOB libFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}  "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp") # select all .cpp-files
if(MSVC)
    file(GLOB headerFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}  "${CMAKE_CURRENT_SOURCE_DIR}/../include/sdsl/*.hpp") # select all .hpp-files
endif()

set( sdsl_SRCS ${libFiles} ${headerFiles})

add_library( sdsl ${sdsl_SRCS} )

install(TARGETS sdsl
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)
        
math(EXPR SOVERSION "${LIBRARY_VERSION_MAJOR}+1")

set_target_properties(sdsl PROPERTIES
        VERSION "${LIBRARY_VERSION_FULL}"
        SOVERSION "${SOVERSION}"
        #	DEFINE_SYMBOL SDSL_BUILD_DLL
        #	RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/../examples"
)

=== test/CMakeLists.txt ===
SET(sdsl_tests "")
SET(generated_files "")

FILE(STRINGS ${CMAKE_CURRENT_LIST_DIR}/download.config download_config_lines REGEX "^[^#].*")
FOREACH(download_config_line ${download_config_lines})
    LIST(GET download_config_line 0 download_file)
    LIST(GET download_config_line 1 download_url)
    STRING(REPLACE ".tar.gz" "" download_file_we ${download_file})
    SET(abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${download_file_we})
    
    ADD_CUSTOM_COMMAND(OUTPUT ${abs_test_case_name}
                      COMMAND ${CMAKE_COMMAND} -Ddownload_url=${download_url} -Dtest_case_dir=${CMAKE_CURRENT_LIST_DIR}/test_cases -P ${CMAKE_CURRENT_LIST_DIR}/download.cmake
                      WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                      COMMENT "Checking or downloading test case ${download_file}."
                      VERBATIM
    )
    ADD_CUSTOM_TARGET(${download_file_we}
                      DEPENDS ${abs_test_case_name})
    LIST(APPEND generated_files ${abs_test_case_name})
ENDFOREACH(download_config_line)


FILE(GLOB SDSL_HEADER_ALL ${CMAKE_CURRENT_BINARY_DIR}/../include/sdsl/*.hpp)
STRING(REGEX REPLACE "([^;]+)[;]" "#include \"\\1\"\\n" SDSL_INCLUDE_ALL "${SDSL_HEADER_ALL};")                                                                       
STRING(REGEX REPLACE "${CMAKE_CURRENT_BINARY_DIR}/\\.\\./include/" "" SDSL_INCLUDE_ALL "${SDSL_INCLUDE_ALL}")                                                                       

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/compile_test.cpp.cmake"
               "${CMAKE_CURRENT_SOURCE_DIR}/compile_test.cpp" @ONLY)

FILE(GLOB test_sources ${CMAKE_CURRENT_SOURCE_DIR}/*_test.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../include
                    ${CMAKE_CURRENT_BINARY_DIR}/../external/libdivsufsort/include
                    ${gtest_SOURCE_DIR}/include
)

LINK_LIBRARIES(sdsl gtest divsufsort divsufsort64)

ADD_EXECUTABLE(int_vector_generator EXCLUDE_FROM_ALL int_vector_generator.cpp)
ADD_EXECUTABLE(bit_vector_generator EXCLUDE_FROM_ALL bit_vector_generator.cpp)
ADD_EXECUTABLE(replace_int_vector_value EXCLUDE_FROM_ALL replace_int_vector_value.cpp)

SET(tmp_dir ${CMAKE_CURRENT_LIST_DIR}/tmp)
FOREACH(test_source ${test_sources})
    GET_FILENAME_COMPONENT(test_name_we ${test_source} NAME_WE)

    STRING(REGEX REPLACE "_" "-" test_name_hy ${test_name_we})

    ADD_EXECUTABLE(${test_name_we} EXCLUDE_FROM_ALL ${test_name_we}.cpp)

    SET(config_file ${CMAKE_CURRENT_SOURCE_DIR}/${test_name_we}.config)
# (1) Handle tests without .config file
    IF(NOT EXISTS ${config_file})
        ADD_CUSTOM_TARGET(${test_name_hy}
            COMMAND $<TARGET_FILE:${test_name_we}> ${tmp_dir}
            DEPENDS test/${test_name_we} ${test_name_we}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
            COMMENT "Execute ${test_name_hy}."
        )
        LIST(APPEND sdsl_tests ${test_name_hy})
# (2) Handle tests with .config file        
    ELSE(NOT EXISTS ${config_file})
        SET(test_targets "")
        FILE(STRINGS ${config_file} config_lines REGEX "^[^#].+")
        SET(config_line_cnt 0)
        FOREACH(config_line ${config_lines})
            MATH(EXPR config_line_cnt ${config_line_cnt}+1)
# (2.1) Handle tests with simple .config file (only one input file)
            IF("${config_line}" MATCHES "^[^;]+$")
                GET_FILENAME_COMPONENT(test_case_name ${config_line} NAME)
                SET(abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})
               
                SET(int_vec_regex "int-vec\\.[0-9]+\\.[0-9]+\\..+")
                SET(bit_vec_regex "bit-vec\\.*")
                IF("${test_case_name}" MATCHES "${int_vec_regex}")
                    STRING(REPLACE "int-vec." "" test_case_suf ${test_case_name})
                    #  insert semicolons to get a list :)
                    STRING(REPLACE "." ";" test_case_param ${test_case_suf}) 

                    ADD_CUSTOM_COMMAND(OUTPUT ${abs_test_case_name}
                                       COMMAND $<TARGET_FILE:int_vector_generator> ${abs_test_case_name}  ${test_case_param} 
                                       DEPENDS int_vector_generator
                                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                       COMMENT "Generating test case ${test_case_name}."
                                       VERBATIM
                    )
                    LIST(APPEND generated_files ${abs_test_case_name})
                ELSEIF("${test_case_name}" MATCHES "${bit_vec_regex}")   
                    STRING(REPLACE "bit-vec." "" test_case_param ${test_case_name})
                    ADD_CUSTOM_COMMAND(OUTPUT ${abs_test_case_name}
                                       COMMAND $<TARGET_FILE:bit_vector_generator> ${abs_test_case_name} ${test_case_param} 
                                       DEPENDS bit_vector_generator
                                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                       COMMENT "Generating test case ${test_case_name}."
                                       VERBATIM
                    )
                    LIST(APPEND generated_files ${abs_test_case_name})
                ENDIF("${test_case_name}" MATCHES "${int_vec_regex}")

                SET(test_target ${test_name_hy}_${test_case_name})
                ADD_CUSTOM_TARGET(${test_target}
                    COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir}/${test_name_we}_${test_case_name} ${tmp_dir}
                    DEPENDS ${abs_test_case_name} ${tmp_dir} ${test_name_we}
                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR} 
                    COMMENT "Execute ${test_name_hy} on ${test_case_name}."
                )
                LIST(APPEND test_targets ${test_target})
            ELSE("${config_line}" MATCHES "^[^;]+$")
#               Handle Cs[a|t]IntTest
                IF ("${test_name_we}" MATCHES "cs[a|t]_int_test") 
                    LIST(GET config_line 0 test_case_name)
                    SET(abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})

                    SET(int_vec_sa_regex "int-vec-sa\\.[0-9]+\\.[0-9]+\\..+")
                    IF("${test_case_name}" MATCHES "${int_vec_sa_regex}")
                        STRING(REPLACE "int-vec-sa." "" test_case_suf ${test_case_name})
                        #  insert semicolons to get a list :)
                        STRING(REPLACE "." ";" test_case_param ${test_case_suf}) 

                        ADD_CUSTOM_COMMAND(OUTPUT ${abs_test_case_name}
                                           COMMAND $<TARGET_FILE:int_vector_generator> ${abs_test_case_name}  ${test_case_param} 
                                           COMMAND $<TARGET_FILE:replace_int_vector_value> ${abs_test_case_name} 0 1
                                           DEPENDS int_vector_generator replace_int_vector_value 
                                           WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                           COMMENT "Generating test case ${test_case_name}."
                                           VERBATIM
                        )
                        LIST(APPEND generated_files ${abs_test_case_name})
                    ENDIF("${test_case_name}" MATCHES "${int_vec_sa_regex}")


                    LIST(GET config_line 1 num_byte)
                    SET(test_target ${test_name_hy}_${test_case_name}_${num_byte})
                    ADD_CUSTOM_TARGET(${test_target}
                        COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${num_byte} ${tmp_dir}/${test_name_we}_${tase_case_name}_${num_byte} ${tmp_dir}
                        DEPENDS ${abs_test_case_name} ${tmp_dir} ${test_name_we}
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                        COMMENT "Execute ${test_name_hy} on ${test_case_name}."        
                    )
                    LIST(APPEND test_targets ${test_target})
#               Handle K2TreapTest    
                ELSEIF("${test_name_we}" MATCHES "k2_treap_test")
                    SET(concat_config "")
#                    STRING(CONCAT concat_config ${config_line})
                    FOREACH(item ${config_line})
                        SET(concat_config "${conact_config}${item}")
                    ENDFOREACH(item)
                    SET(k2dim x y w)
                    LIST(GET config_line 0 test_case_name)
                    SET(test_case_name "k2-${concat_config}")
                    SET(abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})
                    SET(abs_test_case_name_list "")
                    FOREACH(i 0 1 2)
                        LIST(GET k2dim ${i} dim)
                        SET(local_abs_test_case_name ${abs_test_case_name}.${dim})
                        LIST(APPEND abs_test_case_name_list ${local_abs_test_case_name})
                        LIST(GET config_line ${i} test_case_suf)
                        STRING(REPLACE "." ";" test_case_param ${test_case_suf})
                        ADD_CUSTOM_COMMAND(OUTPUT ${local_abs_test_case_name}
                                COMMAND $<TARGET_FILE:int_vector_generator> ${local_abs_test_case_name} ${test_case_param}
                                DEPENDS int_vector_generator
                                WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                COMMENT "Generating test case ${test_case_name}."
                                VERBATIM        
                        )
                    ENDFOREACH(i)
                    ADD_CUSTOM_TARGET(${test_case_name} 
                            DEPENDS ${abs_test_case_name_list})
                    SET(test_target ${test_name_hy}_${test_case_name})
                    ADD_CUSTOM_TARGET(${test_target}
                                COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir}/${test_name_we}_${test_case_name}
                                DEPENDS ${test_case_name} ${tmp_dir} ${test_name_we}
                                WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                COMMENT "Execute ${test_name_hy} on ${test_case_name}."
                            )
                    LIST(APPEND test_targets ${test_target})
                ENDIF("${test_name_we}" MATCHES "cs[a|t]_int_test")
            ENDIF("${config_line}" MATCHES "^[^;]+$")
        ENDFOREACH(config_line)
        ADD_CUSTOM_TARGET(${test_name_hy} DEPENDS ${test_targets}) 
        LIST(APPEND sdsl_tests ${test_name_hy})
    ENDIF(NOT EXISTS ${config_file})
ENDFOREACH(test_source)

ADD_CUSTOM_TARGET(test-sdsl DEPENDS ${sdsl_tests})

ADD_CUSTOM_TARGET(clean-test
                 COMMAND ${CMAKE_COMMAND} -E remove -f ${generated_files}
                 COMMENT "Remove generated and downloaded test inputs.")


# TODO: special handling for in-memory test

=== tutorial/Makefile ===
include ../Make.helper
CXX_FLAGS=$(MY_CXX_FLAGS) $(MY_CXX_OPT_FLAGS) -I$(INC_DIR) -L$(LIB_DIR) 
CCLIB=-lsdsl -ldivsufsort -ldivsufsort64 
SOURCES=$(wildcard *.cpp)
EXECS=$(SOURCES:.cpp=.x)

all: $(EXECS)

build-test: $(EXECS)
	        
%.x:%.cpp
	$(MY_CXX) $(CXX_FLAGS) -o $@ $< $(CCLIB) $(LDFLAGS)

clean:
	rm -f $(EXECS)
	rm -rf *.dSYM

=== benchmark/document_retrieval/Makefile ===
include ../Make.helper
CXX_FLAGS = $(MY_CXX_FLAGS) $(MY_CXX_OPT_FLAGS) -I$(INC_DIR) -L$(LIB_DIR)  
LIBS = -lsdsl -ldivsufsort -ldivsufsort64
SRC_DIR = src
TMP_DIR = ../tmp
PAT_DIR = pattern
BIN_DIR = bin

TC_PATHS:=$(call config_column,test_case.config,2)
TC_PATHS_INT:=$(call config_column,test_case_int.config,2)
TC_DICT_PATHS:=$(call config_column,dic.config,2)
TC_IDS:=$(call config_ids,test_case.config)
TC_IDS_INT:=$(call config_ids,test_case_int.config)
IDX_IDS:=$(call config_ids,index.config)
IDX_IDS_INT:=$(call config_ids,index_int.config)
PAT_LENS:=$(call config_column,pattern_length.config,1)
PAT_LENS_INT:=$(call config_column,pattern_length_int.config,1)

RESULT_FILE=results/all.txt
RESULT_FILE_INT=results/all_int.txt

QUERY_EXECS     = $(foreach IDX_ID,$(IDX_IDS),$(BIN_DIR)/query_idx_$(IDX_ID))
QUERY_EXECS_INT = $(foreach IDX_ID,$(IDX_IDS_INT),$(BIN_DIR)/query_int_idx_$(IDX_ID))
BUILD_EXECS     = $(foreach IDX_ID,$(IDX_IDS),$(BIN_DIR)/build_idx_$(IDX_ID))
BUILD_EXECS_INT = $(foreach IDX_ID,$(IDX_IDS_INT),$(BIN_DIR)/build_int_idx_$(IDX_ID))
SIZES_EXECS     = $(foreach IDX_ID,$(IDX_IDS),$(BIN_DIR)/size_of_idx_$(IDX_ID))
SIZES_EXECS_INT = $(foreach IDX_ID,$(IDX_IDS_INT),$(BIN_DIR)/size_of_int_idx_$(IDX_ID))
PATTERNS        = $(foreach TC_ID,$(TC_IDS),\
				    $(foreach PAT_LEN,$(PAT_LENS),$(PAT_DIR)/$(TC_ID).$(PAT_LEN).pattern))
PATTERNS_INT    = $(foreach TC_ID,$(TC_IDS_INT),\
				    $(foreach PAT_LEN,$(PAT_LENS_INT),$(PAT_DIR)/$(TC_ID).$(PAT_LEN).pattern.int))
INDEXES         = $(foreach IDX_ID,$(IDX_IDS),\
		            $(foreach TC_ID,$(TC_IDS),indexes/$(TC_ID).$(IDX_ID).byte))
INDEXES_INT     = $(foreach IDX_ID,$(IDX_IDS_INT),\
		            $(foreach TC_ID,$(TC_IDS_INT),indexes/$(TC_ID).$(IDX_ID).int))
SIZES           = $(foreach IDX_ID,$(IDX_IDS),\
		            $(foreach TC_ID,$(TC_IDS),info/$(TC_ID).$(IDX_ID).size))
SIZES_INT       = $(foreach IDX_ID,$(IDX_IDS_INT),\
		            $(foreach TC_ID,$(TC_IDS_INT),info/$(TC_ID).$(IDX_ID).size.int))
HTML            = $(foreach IDX_ID,$(IDX_IDS),\
		            $(foreach TC_ID,$(TC_IDS),info/$(TC_ID).$(IDX_ID).byte.html))
HTML_INT        = $(foreach IDX_ID,$(IDX_IDS_INT),\
		            $(foreach TC_ID,$(TC_IDS_INT),info/$(TC_ID).$(IDX_ID).int.html))
TIME_FILES      = $(foreach IDX_ID,$(IDX_IDS),\
		            $(foreach TC_ID,$(TC_IDS),\
					  $(foreach PAT_LEN,$(PAT_LENS),results/$(TC_ID).$(IDX_ID).$(PAT_LEN).byte)))
TIME_FILES_INT  = $(foreach IDX_ID,$(IDX_IDS_INT),\
		            $(foreach TC_ID,$(TC_IDS_INT),\
					  $(foreach PAT_LEN,$(PAT_LENS_INT),results/$(TC_ID).$(IDX_ID).$(PAT_LEN).int)))
COMP_FILES      = $(addsuffix .z.info,$(TC_PATHS) $(TC_PATHS_INT))

HELPER_BINS     = $(BIN_DIR)/gen_pattern $(BIN_DIR)/gen_pattern_int \
		          $(BIN_DIR)/word_pat2char_pat

all: $(BUILD_EXECS) $(BUILD_EXECS_INT) \
	 $(QUERY_EXECS) $(QUERY_EXECS_INT) \
	 $(SIZES_EXECS) $(SIZES_EXECS_INT) \
	 $(HELPER_BINS)

info: $(SIZES_EXECS) $(SIZES_EXECS_INT) $(SIZES) \
	  $(SIZES_INT) $(HTML_INT) $(HTML) \
	  info/sizes.txt \
	  info/sizes_int.txt

info/sizes.txt: $(SIZES)
	@cat $(SIZES) > $@

info/sizes_int.txt: $(SIZES)
	@cat $(SIZES_INT) > $@

indexes: $(INDEXES) $(INDEXES_INT)

input: $(TC_PATHS) $(TC_PATHS_INT) $(TC_DICT_PATHS)

pattern: input $(PATTERNS) $(BIN_DIR)/gen_pattern $(PATTERNS_INT) $(BIN_DIR)/gen_pattern_int

compression: input $(COMP_FILES)

timing: input indexes pattern $(TIME_FILES) $(TIME_FILES_INT) compression info
	@cat $(TIME_FILES) > $(RESULT_FILE)
	@cat $(TIME_FILES_INT) > $(RESULT_FILE_INT)
	@cd visualize; make

# results/[TC_ID].[IDX_ID].[PAT_LEN].byte
results/%.byte: $(BUILD_EXECS) $(QUERY_EXECS) $(INDEXES) $(PATTERNS)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval PAT_LEN:=$(call dim,3,$*)) 
	$(eval TC_NAME:=$(call config_select,test_case.config,$(TC_ID),3))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# test_case = $(TC_NAME)" >>  $@
	@echo "Run timing for $(IDX_ID) on $(TC_ID) with patterns of length $(PAT_LEN)"
	@$(BIN_DIR)/query_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).byte \
		     $(PAT_DIR)/$(TC_ID).$(PAT_LEN).pattern >> $@ 

# results/[TC_ID].[IDX_ID].[PAT_LEN].byte
results/%.int: $(BUILD_EXECS) $(QUERY_EXECS_INT) $(INDEXES_INT) $(PATTERNS_INT)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval PAT_LEN:=$(call dim,3,$*)) 
	$(eval TC_NAME:=$(call config_select,test_case_int.config,$(TC_ID),3))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# test_case = $(TC_NAME)" >>  $@
	@echo "Run timing for $(IDX_ID) on $(TC_ID) with patterns of length $(PAT_LEN)"
	@$(BIN_DIR)/query_int_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).int \
		     $(PAT_DIR)/$(TC_ID).$(PAT_LEN).pattern.int >> $@ 
 
 

# indexes/[TC_ID].[IDX_ID].byte
indexes/%.byte: $(BUILD_EXECS)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case.config,$(TC_ID),2))
	@echo "Building index $(IDX_ID) on $(TC)"
	@$(BIN_DIR)/build_idx_$(IDX_ID) $(TC) $(TMP_DIR) $@

# indexes/[TC_ID].[IDX_ID].int
indexes/%.int: $(BUILD_EXECS_INT)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case_int.config,$(TC_ID),2))
	@echo "Building index $(IDX_ID) on $(TC)"
	@$(BIN_DIR)/build_int_idx_$(IDX_ID) $(TC) $(TMP_DIR) $@

# info/[TC_ID].[IDX_ID]
info/%.size: $(INDEXES)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval SIZE:=$(call file_size,$(TC)))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# text_size = $(SIZE)" >> $@
	@echo "Get size of index for $(IDX_ID) on $(TC_ID)"
	@$(BIN_DIR)/size_of_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).byte >> $@

# info/[TC_ID].[IDX_ID]
info/%.size.int: $(INDEXES_INT)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case_int.config,$(TC_ID),2))
	$(eval SIZE:=$(call file_size,$(TC)))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# text_size = $(SIZE)" >> $@
	@echo "Get size of index for $(IDX_ID) on $(TC_ID)"
	@$(BIN_DIR)/size_of_int_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).int >> $@

# info/[TC_ID].[IDX_ID]
info/%.byte.html: $(INDEXES)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval SIZE:=$(call file_size,$(TC)))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# text_size = $(SIZE)" >> $@
	@echo "Get html of index for $(IDX_ID) on $(TC_ID)"
	@$(BIN_DIR)/size_of_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).byte $@

# info/[TC_ID].[IDX_ID]
info/%.int.html: $(INDEXES)
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval IDX_ID:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case_int.config,$(TC_ID),2))
	$(eval SIZE:=$(call file_size,$(TC)))
	@echo "# TC_ID = $(TC_ID)" > $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# text_size = $(SIZE)" >> $@
	@echo "Get html of index for $(IDX_ID) on $(TC_ID)"
	@$(BIN_DIR)/size_of_int_idx_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID).int $@



# $(PAT_DIR)/[TC_ID].[PAT_LEN].pattern.int
$(PAT_DIR)/%.pattern.int: $(BIN_DIR)/gen_pattern_int $(BIN_DIR)/word_pat2char_pat
	@echo $*
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval PAT_LEN:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case_int.config,$(TC_ID),2))
	$(BIN_DIR)/gen_pattern_int $(TC) $(TMP_DIR)/$(TC_ID).pat.csa $(TMP_DIR) $(PAT_LEN) 200 $@
	$(eval DIC_PATH:=$(call config_select,dic.config,$(TC_ID),2))
	$(BIN_DIR)/word_pat2char_pat $@ $(DIC_PATH) > $@.txt

# $(PAT_DIR)/[TC_ID].[PAT_LEN].pattern	
$(PAT_DIR)/%.pattern: $(BIN_DIR)/gen_pattern
	@echo $*
	$(eval TC_ID:=$(call dim,1,$*)) 
	$(eval PAT_LEN:=$(call dim,2,$*)) 
	$(eval TC:=$(call config_select,test_case.config,$(TC_ID),2))
	$(BIN_DIR)/gen_pattern $(TC) $(TMP_DIR)/$(TC_ID).pat.csa $(TMP_DIR) $(PAT_LEN) 200 $@

$(BIN_DIR)/gen_pattern: $(SRC_DIR)/gen_pattern.cpp
	@echo "Build pattern generation program"
	$(MY_CXX) $(CXX_FLAGS) $(SRC_DIR)/gen_pattern.cpp \
				-L$(LIB_DIR) -I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/gen_pattern_int: $(SRC_DIR)/gen_pattern.cpp 
	@echo "Build pattern generation program"
	$(MY_CXX) $(CXX_FLAGS) $(SRC_DIR)/gen_pattern.cpp \
	          -DINT_ALPHABET \
			  -L$(LIB_DIR) -I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/size_of_idx_%: $(SRC_DIR)/size_of_idx.cpp
	$(eval IDX_TYPE:=$(call config_select,index.config,$*,2))
	@echo "Build size info program"
	$(MY_CXX) $(CXX_FLAGS) $(SRC_DIR)/size_of_idx.cpp \
				-DIDX_TYPE="$(IDX_TYPE)" \
				-L$(LIB_DIR) -I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/size_of_int_idx_%: $(SRC_DIR)/size_of_idx.cpp
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$*,2))
	@echo "Build size info program"
	$(MY_CXX) $(CXX_FLAGS) $(SRC_DIR)/size_of_idx.cpp \
				-DIDX_TYPE="$(IDX_TYPE)" \
				-L$(LIB_DIR) -I$(INC_DIR) -o $@ $(LIBS)

# $(BIN_DIR)/build_idx_[IDX_ID]
$(BIN_DIR)/build_idx_%: $(SRC_DIR)/build_idx.cpp index.config
	$(eval IDX_TYPE:=$(call config_select,index.config,$*,2))
	@echo "Compiling build_idx_$*"
	$(MY_CXX) $(CXX_FLAGS) \
					-DIDX_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/build_idx.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

# $(BIN_DIR)/build_idx_[IDX_ID]
$(BIN_DIR)/build_int_idx_%: $(SRC_DIR)/build_idx.cpp index_int.config
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$*,2))
	@echo "Compiling build_int_idx_$*"
	$(MY_CXX) $(CXX_FLAGS) \
					-DIDX_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/build_idx.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

# Targets for the count experiment. $(BIN_DIR)/query_idx_[IDX_ID]
$(BIN_DIR)/query_idx_%: $(SRC_DIR)/query_idx.cpp index.config 
	$(eval IDX_TYPE:=$(call config_select,index.config,$*,2))
	@echo "Compiling query_idx_$*"
	$(MY_CXX) $(CXX_FLAGS) \
					-DIDX_ID=\"$*\" -DIDX_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/query_idx.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

# Targets for the count experiment. $(BIN_DIR)/query_idx_[IDX_ID]
$(BIN_DIR)/query_int_idx_%: $(SRC_DIR)/query_idx.cpp index_int.config 
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$*,2))
	@echo "Compiling query_int_idx_$*"
	$(MY_CXX) $(CXX_FLAGS) \
					-DIDX_ID=\"$*\" -DIDX_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/query_idx.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/word_pat2char_pat: $(SRC_DIR)/word_pat2char_pat.cpp
	@echo "Compiling word_pat2char_pat.cpp"
	$(MY_CXX) $(CXX_FLAGS) \
			  $(SRC_DIR)/word_pat2char_pat.cpp \
			  -o $@ 



dic/%: 
	$(eval URL:=$(call config_filter,dic.config,$@,4))
	@$(if $(URL),,\
		$(error "No download link for dictionary $@") )
	@echo "Download dictionary from $(URL) using curl"
	$(eval DEST_DIR:=$(shell dirname $@))
	cd $(DEST_DIR); curl -O $(URL)
	$(eval FILE:=$(DEST_DIR)/$(notdir $(URL)))
	@$(if $(filter-out ".gz",$(FILE)),\
		echo "Extract file $(FILE) using gunzip";\
		gunzip $(FILE))

../data/%.int.sdsl: 
	$(eval URL:=$(call config_filter,test_case_int.config,$@,4))
	@$(if $(URL),,\
		$(error "No download link nor generation program specified for test case $@") )
	@echo "Download input from $(URL) using curl"
	$(eval DEST_DIR:=$(shell dirname $@))
	cd $(DEST_DIR); curl -O $(URL)
	$(eval FILE:=$(DEST_DIR)/$(notdir $(URL)))
	@$(if $(filter-out ".gz",$(FILE)),\
		echo "Extract file $(FILE) using gunzip";\
		gunzip $(FILE))


include ../Make.download

clean-build:
	@echo "Remove executables"
	rm -f $(QUERY_EXECS) $(SIZES_EXECS) $(BUILD_EXECS) \
		  $(QUERY_EXECS_INT) $(SIZES_EXECS_INT) $(BUILD_EXECS_INT) \
		  $(HELPER_BINS)

clean: clean-build
	@echo "Remove info files and indexes"
	rm -f $(INDEXES) $(INDEXES_INT)

cleanresults: 
	@echo "Remove result files and pattern"
	rm -f $(TIME_FILES) \
		  $(RESULT_FILE) \
		  $(TIME_FILES_INT) \
		  $(RESULT_FILE_INT) \
	      $(SIZES) $(SIZES_INT) \
		  $(HTML) $(HTML_INT)
	rm -f $(PATTERNS) $(PATTERNS_INT)

cleanall: clean cleanresults

=== benchmark/indexing_count/Makefile ===
include ../Make.helper
CFLAGS = $(MY_CXX_FLAGS) # in compile_options.config
LIBS = -lsdsl -ldivsufsort -ldivsufsort64
SRC_DIR = src
TMP_DIR = ../tmp
PAT_DIR = pattern
BIN_DIR = bin

TC_PATHS:=$(call config_column,test_case.config,2)
TC_IDS:=$(call config_ids,test_case.config)
IDX_IDS:=$(call config_ids,index.config)
COMPILE_IDS:=$(call config_ids,compile_options.config)

RESULT_FILE=results/all.txt

QUERY_EXECS = $(foreach IDX_ID,$(IDX_IDS),\
		         $(foreach COMPILE_ID,$(COMPILE_IDS),$(BIN_DIR)/query_idx_$(IDX_ID).$(COMPILE_ID)))
BUILD_EXECS = $(foreach IDX_ID,$(IDX_IDS),$(BIN_DIR)/build_idx_$(IDX_ID))
INFO_EXECS  = $(foreach IDX_ID,$(IDX_IDS),$(BIN_DIR)/info_$(IDX_ID))
PATTERNS    = $(foreach TC_ID,$(TC_IDS),$(PAT_DIR)/$(TC_ID).pattern)
INDEXES     = $(foreach IDX_ID,$(IDX_IDS),\
		         $(foreach TC_ID,$(TC_IDS),indexes/$(TC_ID).$(IDX_ID)))
INFO_FILES  = $(foreach IDX_ID,$(IDX_IDS),\
		         $(foreach TC_ID,$(TC_IDS),info/$(TC_ID).$(IDX_ID).html))
TIME_FILES  = $(foreach IDX_ID,$(IDX_IDS),\
		         $(foreach TC_ID,$(TC_IDS),\
					 $(foreach COMPILE_ID,$(COMPILE_IDS),results/$(TC_ID).$(IDX_ID).$(COMPILE_ID))))
COMP_FILES  = $(addsuffix .z.info,$(TC_PATHS))

all: $(BUILD_EXECS) $(QUERY_EXECS) $(INFO_EXECS)

info: $(INFO_EXECS) $(INFO_FILES)

indexes: $(INDEXES)

input: $(TC_PATHS)

pattern: input $(PATTERNS) $(BIN_DIR)/genpatterns

compression: input $(COMP_FILES)

timing: input $(INDEXES) pattern $(TIME_FILES) compression info
	@cat $(TIME_FILES) > $(RESULT_FILE)
	@cd visualize; make

# results/[TC_ID].[IDX_ID].[COMPILE_ID]
results/%: $(BUILD_EXECS) $(QUERY_EXECS) $(PATTERNS) $(INDEXES)
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval COMPILE_ID:=$(call dim,3,$*))
	$(eval TC_NAME:=$(call config_select,test_case.config,$(TC_ID),3))
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@echo "# test_case = $(TC_NAME)" >>  $@
	@echo "Run timing for $(IDX_ID).$(COMPILE_ID) on $(TC_ID)"
	$(BIN_DIR)/query_idx_$(IDX_ID).$(COMPILE_ID) \
		indexes/$(TC_ID) C < $(PAT_DIR)/$(TC_ID).pattern 2>> $@


# indexes/[TC_ID].[IDX_ID]
indexes/%: $(BUILD_EXECS)
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval TC:=$(call config_select,test_case.config,$(TC_ID),2))
	@echo "Building index $(IDX_ID) on $(TC)"
	$(BIN_DIR)/build_idx_$(IDX_ID) $(TC) $(TMP_DIR) $@

# info/[TC_ID].[IDX_ID]
info/%.html: $(INDEXES)
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	@echo "Generating info for $(IDX_ID) on $(TC_ID)"
	@$(BIN_DIR)/info_$(IDX_ID) indexes/$(TC_ID).$(IDX_ID) > $@

$(PAT_DIR)/%.pattern: $(BIN_DIR)/genpatterns
	@echo $*
	$(eval TC:=$(call config_select,test_case.config,$*,2))
	$(BIN_DIR)/genpatterns $(TC) 20 50000 $@

$(BIN_DIR)/genpatterns: $(SRC_DIR)/genpatterns.c
	@echo "Build pattern generation program"
	@$(MY_CC) -O3 -o $@ $(SRC_DIR)/genpatterns.c

# $(BIN_DIR)/build_idx_[IDX_ID]
$(BIN_DIR)/build_idx_%: $(SRC_DIR)/build_index_sdsl.cpp index.config
	$(eval IDX_TYPE:=$(call config_select,index.config,$*,2))
	@echo "Compiling build_idx_$*"
	@$(MY_CXX) $(CFLAGS) -O3 -DNDEBUG \
					-DSUF=\"$*\" -DCSA_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/build_index_sdsl.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

# Targets for the count experiment. $(BIN_DIR)/count_queries_[IDX_ID].[COMPILE_ID]
$(BIN_DIR)/query_idx_%: $(SRC_DIR)/run_queries_sdsl.cpp index.config
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval COMPILE_ID:=$(call dim,2,$*))
	$(eval IDX_TYPE:=$(call config_select,index.config,$(IDX_ID),2))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	@echo "Compiling query_idx_$*"
	@$(MY_CXX) $(CFLAGS) $(COMPILE_OPTIONS) \
					-DSUF=\"$(IDX_ID)\" -DCSA_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/run_queries_sdsl.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

# Targets for the executables which output the indexes structure.
$(BIN_DIR)/info_%: $(SRC_DIR)/info.cpp index.config
	$(eval IDX_TYPE:=$(call config_select,index.config,$*,2))
	@echo "Compiling info_$*"
	@$(MY_CXX) $(CFLAGS) -O3 -DNDEBUG \
					-DSUF=\"$*\" -DCSA_TYPE="$(IDX_TYPE)" \
					-L$(LIB_DIR) $(SRC_DIR)/info.cpp \
					-I$(INC_DIR) -o $@ $(LIBS)

include ../Make.download

clean-build:
	@echo "Remove executables"
	@rm -f $(QUERY_EXECS) $(BUILD_EXECS) $(INFO_EXECS)

clean:
	@echo "Remove executables and indexes"
	@rm -f $(QUERY_EXECS) $(BUILD_EXECS) $(INFO_EXECS) \
		   $(INFO_FILES) $(INDEXES) $(BIN_DIR)/genpatterns

cleanresults:
	@echo "Remove result files"
	@rm -f $(TIME_FILES) $(RESULT_FILE) $(INFO_FILES)
	@rm -f $(PATTERNS)

cleanall: clean cleanresults
	@echo "Remove all generated files."
	@rm -f $(TMP_DIR)/*
	@rm -f $(PAT_DIR)/*

=== benchmark/lcp/Makefile ===
include ../../Make.helper
CFLAGS = $(MY_CXX_FLAGS) 
SRC_DIR = src
BIN_DIR = bin
LIBS = -lsdsl -ldivsufsort -ldivsufsort64

C_OPTIONS:=$(call config_ids,compile_options.config)
TC_IDS:=$(call config_ids,test_case.config)
LCP_IDS:=$(call config_ids,lcp.config)


DL = ${foreach TC_ID,$(TC_IDS),$(call config_select,test_case.config,$(TC_ID),2)}

LCP_EXECS = $(foreach LCP_ID,$(LCP_IDS),$(BIN_DIR)/build_$(LCP_ID))

RES_FILES = $(foreach TC_ID,$(TC_IDS),\
					results/$(TC_ID))

RESULT_FILE=results/all.txt

execs: $(BIN_DIR)/prep_sa_bwt $(LCP_EXECS)

timing: execs $(RES_FILES)
	@cat $(RES_FILES) > $(RESULT_FILE)
	@cd visualize;make

$(BIN_DIR)/prep_sa_bwt: $(SRC_DIR)/create_sa_bwt.cpp 
	@echo "Compiling prep_sa_bwt"
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -L${LIB_DIR}\
		$(SRC_DIR)/create_sa_bwt.cpp -I${INC_DIR} -o bin/prep_sa_bwt $(LIBS)
	
precalc%: test_case.config $(DL) lcp.config
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval LCP_TEX_NAME:=$(call config_select,lcp.config,$(LCP_ID),3))
	$(eval TC_TEX_NAME:=$(call config_select,test_case.config,$(TC_ID),3))
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval TC_SIZE:=$(shell wc -c <$(TC_PATH)))
	@echo "Running test case: $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" > results/$(TC_ID)
	@echo "# TC_TEX_NAME = $(TC_TEX_NAME)">> results/$(TC_ID)
	@echo "# TC_SIZE = $(TC_SIZE)">> results/$(TC_ID)
	@$(BIN_DIR)/prep_sa_bwt $(TC_PATH) >> results/$(TC_ID) 

results/%: precalc%
	@$(foreach LCP_EXEC,$(LCP_EXECS),$(shell $(LCP_EXEC) >>$@;rm -f lcp_tmp.sdsl isa_tmp.sdsl)) 
	@rm *.sdsl

$(BIN_DIR)/build_%: $(SRC_DIR)/create_lcp.cpp lcp.config 
	$(eval LCP_ID:=$(call dim,1,$*))
	$(eval LCP_TYPE:=$(call config_select,lcp.config,$(LCP_ID),2))
	@echo "Compiling build_$*"
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -DLCP_TYPE="$(LCP_TYPE)" -DLCPID="$(LCP_ID)" -L${LIB_DIR}\
		$(SRC_DIR)/create_lcp.cpp -I${INC_DIR} -o $@ $(LIBS)


include ../Make.download

clean-build:
	@echo "Remove executables"
	rm -f $(BIN_DIR)/build*
	rm -f $(BIN_DIR)/prep*

clean-result:
	@echo "Remove results"
	rm -f results/*

cleanall: clean-build clean-result

=== benchmark/suffix_trees/Makefile ===
include ../Make.helper
LIBS=-lsdsl -ldivsufsort -ldivsufsort64
SRC_DIR=src
TMP_DIR=../tmp

TC_IDS:=$(call config_ids,test_case.config)
TC_IDS_INT:=$(call config_ids,test_case_int.config)
TC_PATHS:=$(call config_column,test_case.config,2)
TC_PATHS_INT:=$(call config_column,test_case_int.config,2)
IDX_IDS:=$(call config_ids,index.config)
IDX_IDS_INT:=$(call config_ids,index_int.config)
COMPILE_IDS:=$(call config_ids,compile_options.config)
DEFAULT_COMPILE_ID:=$(word 1, $(COMPILE_IDS))

BUILD_EXECS           = $(foreach IDX_ID,$(IDX_IDS),bin/build_cst_$(IDX_ID))
BUILD_EXECS_INT       = $(foreach IDX_ID,$(IDX_IDS_INT),bin/build_int_cst_$(IDX_ID))
CST_EXECS            = $(foreach IDX_ID,$(IDX_IDS),\
						  $(foreach COMPILE_ID,$(COMPILE_IDS),bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID)))
CST_EXECS_INT        = $(foreach IDX_ID,$(IDX_IDS_INT),\
						  $(foreach COMPILE_ID,$(COMPILE_IDS),bin/time_and_space_int_cst_$(IDX_ID).$(COMPILE_ID)))
NODE_DEPTH_EXECS      = bin/depth_stats bin/depth_stats_int
INDEXES               = $(foreach TC_ID,$(TC_IDS),\
						  $(foreach IDX_ID,$(IDX_IDS),indexes/$(TC_ID).$(IDX_ID).byte))
INDEXES_INT           = $(foreach TC_ID,$(TC_IDS_INT),\
						  $(foreach IDX_ID,$(IDX_IDS_INT),indexes/$(TC_ID).$(IDX_ID).int))
INDEX_FILES           = $(foreach IDX,$(INDEXES),$(IDX))
INDEX_FILES_INT       = $(foreach IDX,$(INDEXES_INT),$(IDX))
RES_FILES             = $(foreach TC_ID,$(TC_IDS),\
						  $(foreach IDX_ID,$(IDX_IDS),\
							$(foreach COMPILE_ID,$(COMPILE_IDS),results/$(TC_ID).$(IDX_ID).$(COMPILE_ID).byte)))
RES_FILES_INT         = $(foreach TC_ID,$(TC_IDS_INT),\
						  $(foreach IDX_ID,$(IDX_IDS_INT),\
							$(foreach COMPILE_ID,$(COMPILE_IDS),results/$(TC_ID).$(IDX_ID).$(COMPILE_ID).int)))
NODE_STATS            = $(foreach TC_ID,$(TC_IDS),stats/$(TC_ID).byte.depth.txt)
NODE_STATS_INT        = $(foreach TC_ID,$(TC_IDS_INT),stats/$(TC_ID).int.depth.txt)

RES_FILE = results/all.txt

all: execs

timing: input\
		$(BUILD_EXECS) $(BUILD_EXECS_INT)\
		$(CST_EXECS) $(CST_EXECS_INT)\
		indexes\
		$(RES_FILES) $(RES_FILES_INT)
	cat $(RES_FILES) $(RES_FILES_INT) > $(RES_FILE)
	@cd visualize; make

depth: input $(NODE_DEPTH_EXECS) $(NODE_STATS) $(NODE_STATS_INT)

input: $(TC_PATHS) $(TC_PATHS_INT)

execs: $(BUILD_EXECS) $(BUILD_EXECS_INT) $(CST_EXECS) $(CST_EXECS_INT) $(NODE_DEPTH_EXECS)

indexes: $(INDEXES) $(INDEXES_INT)

# bin/build_cst_[IDX_ID]
bin/build_cst_%: $(SRC_DIR)/build_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index.config,$(IDX_ID),2))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/build_int_cst_[IDX_ID]
bin/build_int_cst_%: $(SRC_DIR)/build_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$(IDX_ID),2))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/time_and_space_cst_[INDEX_ID].[COMPILE_ID]
bin/time_and_space_cst_%: $(SRC_DIR)/time_and_space_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index.config,$(IDX_ID),2))
	$(eval IDX_REF_TYPE:=$(REF_CST_TYPE))
	$(eval COMPILE_ID:=$(call dim,2,$*))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/time_and_space_int_cst_[INDEX_ID].[COMPILE_ID]
bin/time_and_space_int_cst_%: $(SRC_DIR)/time_and_space_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$(IDX_ID),2))
	$(eval IDX_REF_TYPE:=$(REF_CST_TYPE_INT))
	$(eval COMPILE_ID:=$(call dim,2,$*))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

bin/depth_stats: $(SRC_DIR)/depth_stats.cpp
	$(eval IDX_TYPE:=$(REF_CST_TYPE))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

bin/depth_stats_int: $(SRC_DIR)/depth_stats.cpp
	$(eval IDX_TYPE:=$(REF_CST_TYPE_INT))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# indexes/[TC_ID].[IDX_ID].byte
indexes/%.byte:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval TIME_FILE:=stats/$(TC_ID).$(IDX_ID).construction.html)
	$(eval STATS_FILE:=stats/$(TC_ID).$(IDX_ID).structure.html)
	@echo "Building index $(IDX_ID) on $(TC_ID) (byte alphabet)"
	@bin/build_cst_$(IDX_ID) $(TC_PATH) $(TMP_DIR) $@ $(TIME_FILE) $(STATS_FILE)

# indexes/[TC_ID].[IDX_ID].int
indexes/%.int:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval TC_PATH:=$(call config_select,test_case_int.config,$(TC_ID),2))
	$(eval TIME_FILE:=stats/$(TC_ID).$(IDX_ID).construction.html)
	$(eval STATS_FILE:=stats/$(TC_ID).$(IDX_ID).structure.html)
	@echo "Building index $(IDX_ID) on $(TC_ID) (int alphabet)"
	@bin/build_int_cst_$(IDX_ID) $(TC_PATH) $(TMP_DIR) $@ $(TIME_FILE) $(STATS_FILE)

# Format: results/[TC_ID].[INDEX_ID].[COMPILE_ID].byte
results/%.byte:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval COMPILE_ID:=$(call dim,3,$*))
	@echo "Running bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) on $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) indexes/$(TC_ID).$(IDX_ID).byte >> $@

# Format: results/[TC_ID].[INDEX_ID].[COMPILE_ID].int
results/%.int:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval COMPILE_ID:=$(call dim,3,$*))
	@echo "Running bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) on $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@bin/time_and_space_int_cst_$(IDX_ID).$(COMPILE_ID) indexes/$(TC_ID).$(IDX_ID).int >> $@

# stats/[TC_ID].byte.depth.txt
stats/%.byte.depth.txt:
	$(eval TC_ID:=$*)
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	@echo "Generating node depth statistics for $(TC_ID) (byte alphabet)"
	@bin/depth_stats $(TC_PATH) $(TMP_DIR) >> $@

# stats/[TC_ID].int.depth.txt
stats/%.int.depth.txt:
	$(eval TC_ID:=$*)
	$(eval TC_PATH:=$(call config_select,test_case_int.config,$(TC_ID),2))
	@echo "Generating node depth statistics for $(TC_ID) (int alphabet)"
	@bin/depth_stats_int $(TC_PATH) $(TMP_DIR) >> $@

../data/%:
	$(eval URL:=$(call config_filter,test_case.config,$@,4))
	@$(if $(URL),,\
		$(eval URL:=$(call config_filter,test_case_int.config,$@,4))\
		@$(if $(URL),,\
			$(error "No download link nor generation program specified for test case $@") ) )
	@echo "Download input from $(URL) using curl"
	$(eval DEST_DIR:=$(shell dirname $@))
	cd $(DEST_DIR); curl -O $(URL)
	$(eval FILE:=$(DEST_DIR)/$(notdir $(URL)))
	@$(if $(filter-out ".gz",$(FILE)),\
		echo "Extract file $(FILE) using gunzip";\
		gunzip $(FILE))

clean:
	rm -f $(BUILD_EXECS) $(BUILD_EXECS_INT) $(FCST_EXECS) $(FCST_EXECS_INT) $(FCST_VERIFY_EXECS) $(FCST_VERIFY_EXECS_INT) $(TMP_DIR)/*

clean_indexes:
	rm -f $(INDEX_FILES) $(INDEX_FILES_INT)

clean_results:
	rm -f $(RES_FILES) $(RES_FILES_INT)

cleanall: clean clean_indexes clean_results

=== benchmark/wavelet_trees/Makefile ===
include ../../Make.helper
CFLAGS = $(MY_CXX_FLAGS) 
SRC_DIR = src
BIN_DIR = bin
LIBS = -lsdsl 

C_OPTIONS:=$(call config_ids,compile_options.config)
TC_IDS:=$(call config_ids,test_case.config)
WT_IDS:=$(call config_ids,wt.config)

DL = $(foreach TC_ID,$(TC_IDS),\
		$(call config_select,test_case.config,$(TC_ID),2))
DL_BWT = $(foreach TC_ID,$(TC_IDS),../tmp/BWT.$(TC_ID))

WT_EXECS = $(foreach WT_ID,$(WT_IDS),$(BIN_DIR)/build_$(WT_ID))

RES_FILES = $(foreach WT_ID,$(WT_IDS),\
				$(foreach TC_ID,$(TC_IDS),\
					results/$(WT_ID).$(TC_ID)))

BWT_RES_FILES = $(foreach WT_ID,$(WT_IDS),\
					$(foreach TC_ID,$(TC_IDS),\
						results-bwt/$(WT_ID).$(TC_ID)))

RESULT_FILE=results/all.txt

all: execs 

execs: $(WT_EXECS)

timing: execs $(RES_FILES) 
	@cat $(RES_FILES) > $(RESULT_FILE)
	@cd visualize;make

../tmp/BWT.%: $(DL) $(BIN_DIR)/gen_bwt 
	$(eval TC_ID:=$*)
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval BWT:=$(strip $(call config_select,test_case.config,$(TC_ID),6)))
	$(eval NUM_BYTE:=$(call config_select,test_case.config,$(TC_ID),5))
	@$(BIN_DIR)/gen_bwt $(TC_PATH) ../tmp/BWT.$(TC_ID) ../tmp $(BWT) $(NUM_BYTE)

# Execute $(BIN_DIR)/build_[WT_ID] and write result
results/%: test_case.config $(DL) $(DL_BWT) execs 
	$(eval WT_ID:=$(call dim,1,$*))
	$(eval TC_ID:=$(call dim,2,$*))
	$(eval WT_TEX_NAME:=$(call config_select,wt.config,$(WT_ID),3))
	$(eval TC_TEX_NAME:=$(call config_select,test_case.config,$(TC_ID),3))
	$(eval BWT:=$(strip $(call config_select,test_case.config,$(TC_ID),6)))
	$(eval TC_PATH:=$(if $(findstring BWT,$(BWT)),"../tmp/BWT.$(TC_ID)",$(call config_select,test_case.config,$(TC_ID),2)))
	$(eval TC_TYPE:=$(call config_select,test_case.config,$(TC_ID),5))
	$(eval TC_SIZE:=$(shell wc -c <$(TC_PATH)))
	$(eval ARGS:=$(TC_PATH) $(TC_TYPE) $(TC_ID) $(WT_ID))
	@echo "Running bin/build_$(WT_ID) on $(TC_ID)"
	@echo "# WT_ID = $(WT_ID)" > $@
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# WT_TEX_NAME = $(WT_TEX_NAME)">>$@
	@echo "# TC_TEX_NAME = $(TC_TEX_NAME)">>$@
	@echo "# TC_SIZE = $(TC_SIZE)">>$@
	@$(BIN_DIR)/build_$(WT_ID) $(ARGS) >> $@	

# $(BIN_DIR)/build_[WT_ID]
$(BIN_DIR)/build_%: $(SRC_DIR)/wt_time_and_space.cpp wt.config 
	$(eval WT_ID:=$(call dim,1,$*))
	$(eval WT_TYPE:=$(call config_select,wt.config,$(WT_ID),2))
	@echo "Compiling build_$*"
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -DWT_TYPE="$(WT_TYPE)" -L$(LIB_DIR)\
		$(SRC_DIR)/wt_time_and_space.cpp -I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/gen_bwt: $(SRC_DIR)/gen_bwt.cpp
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -L$(LIB_DIR)\
		$(SRC_DIR)/gen_bwt.cpp -I$(INC_DIR) -o $@ $(LIBS) -ldivsufsort -ldivsufsort64

include ../Make.download

clean-build:
	@echo "Remove executables"
	rm -f $(BIN_DIR)/build*

clean-result:
	@echo "Remove results"
	rm -f results/*

cleanall: clean-build clean-result

=== extras/cheatsheet/Makefile ===

sdsl-cheatsheet.pdf: sdsl-cheatsheet.tex
	pdflatex sdsl-cheatsheet.tex

clean:
	rm -f sdsl-cheatsheet.pdf \
          sdsl-cheatsheet.aux

=== debian/changelog ===
libsdsl (2.1.1+dfsg-6) unstable; urgency=medium

  * Team upload.
  * typo_caught_by_gcc15.patch: new: fix build failure. (Closes: #1097267)
  * cmake-4.patch: new: bump cmake requirement to 3.10. (Closes: #1113197)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.
  * use_debian_packaged_d3.patch: normalize Last-Update.

 -- Étienne Mollier <emollier@debian.org>  Mon, 06 Oct 2025 20:35:05 +0200

libsdsl (2.1.1+dfsg-5) unstable; urgency=medium

  * Team upload.
  * d/control: allow any 64-bit architecture + x32. Closes: #1057248
  * d/clean: two files added to the removal list. Closes: #1045726

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 31 Jul 2024 17:33:30 +0200

libsdsl (2.1.1+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Manuel A. Fernandez Montecelo ]
  * Add support for riscv64 arch. Closes: #1023768

  [ Michael R. Crusoe ]
  * debian/patches/use_debian_packaged_d3.patch doesn't need forwarding
    upstream
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Repository.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 16:55:15 +0200

libsdsl (2.1.1+dfsg-3) unstable; urgency=medium

  * Fic watch file
  * Standards-Version: 4.6.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 07 Dec 2022 07:32:46 +0100

libsdsl (2.1.1+dfsg-2) unstable; urgency=medium

  * Refresh packaging (debhelper 12, std-ver 4.3.0)

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 10 Jan 2019 00:51:44 +0100

libsdsl (2.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Exclude libdivsufsort from upstream source
  * Use d-shlibs
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 24 Sep 2018 20:55:00 +0200

=== debian/control ===
Source: libsdsl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: architecture-is-64-bit [!x32],
               cmake,
               d-shlibs,
               debhelper-compat (= 13),
               libdivsufsort-dev,
               libjs-d3
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/libsdsl
Vcs-Git: https://salsa.debian.org/science-team/libsdsl.git
Homepage: https://github.com/simongog/sdsl-lite

Package: libsdsl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdivsufsort-dev,
         libsdsl3 (= ${binary:Version}),
         ${misc:Depends}
Description: succinct data structure library - development files
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs development files.

Package: libsdsl3
Architecture: any
Multi-Arch: same
Depends: libjs-d3,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: succinct data structure library
 The Succinct Data Structure Library (SDSL) is a powerful and flexible
 C++11 library implementing succinct data structures. In total, the
 library contains the highlights of 40 research publications. Succinct
 data structures can represent an object (such as a bitvector or a
 tree) in space close the information-theoretic lower bound of the
 object while supporting operations of the original object
 efficiently. The theoretical time complexity of an operations
 performed on the classical data structure and the equivalent succinct
 data structure are (most of the time) identical.
 .
 This package installs static library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	cp -a `find . -name libsdsl_static.a` `echo $$(find debian/tmp/usr/lib -name libsdsl.so) | sed 's/\.so$$/.a/'`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
                    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*/*.so

=== debian/watch ===
Version: 5

Template: Github
Owner: simongog
Project: sdsl-lite
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Dversionmangle: auto
Repacksuffix: +dfsg
